#ifndef _ENCDCT_H_
#define _ENCDCT_H_

/*
 * encDct.h
 *
 *    Copyright (c) 1995-2000 Nokia Research Center
 *
 * Contains:
 *    Functions for prediction error coding.
 *
 */


#include "mainFlags.h"
#include "toolDct.h"
#include "toolMCC.h"


/*
 * Defines
 */


/*
 * Structs and typedefs
 */


/*
 * Function prototypes
 */

void encForwardDct(int *diffBlk, int *predBlk, int *origBlk, int *recoBlk,
		   int *sqrErr, int *bitsForCoef, int *quantDctCoeffs,
		   int qp, int sizedx, int sizedy, u_char *zigzagtable,
		   int chroma, int mode, int start,int doReco);

void setLagrangianFlag(int flag);
int  getLagrangianFlag(void);

void setLagrangianCopyRegionFlag(int flag);
int  getLagrangianCopyRegionFlag(void);

long SendDctRegion(struct frame *currFr, /* In:  Current (original) frame  */
                   struct frame *predFr, /* In:  Prediction frame          */
                   int blockInd,         /* In:  Index of the pred block   */
                   struct frame *recoFr, /* Out: Reconstruction frame      */
                   object *currRegion,   /* In:  Ptr to the region to code */
				           object *object_list,
                   int picSizeX,         /* In:  Width of the image        */
                   int picSizeY,         /* In:  Height of the image       */
                   int regionSize,       /* In:  Region size (16 or 8)     */
                   int regionMode,       /* In:  Region mode               */
				           int regionIndex,
                   int predPossible,     /* In:  Is motion pred possible   */
                   int predDirsAvail,    /* In:  Available pred directions */
                   int predDir,          /* In:  Chosen pred direction     */
                   int predSelNeeded,    /* In:  Pred selection needed     */
                   int predSel,          /* In:  Chosen pred selection     */
                   int *motCoefs,        /* In:  (Delta) Motion coeffs     */
                   u_char *pecMode,      /* Out: Pred error coding mode    */
                   int *bitsMode,        /* Out: Bits for mode             */
                   int *bitsMotion,      /* Out: Bits for motion vect field*/
                   int *bitsOvr,         /* Out: Bits for DCT CNC patterns */
                   int *bitsDct,         /* Out: Bits for luma DCT         */
                   int *bitsDctC,        /* Out: Bits for chrom DCT        */
                   int qp,               /* In:  Quant. param. for luma    */
                   int aQP,              /* In:  QP for affine parameters  */
                   float lambda_Y,       /* In:  Lambda param. for luma    */
                   int codePredErr,      /* In:  Test DCT for this region  */
                   int buildReco,        /* In:  Build reconstruction      */
                   int send);            /* In:  Dump output to bitstream  */

long 
SendIntraDctRegion(struct frame *currFr, /* In:  Current (original) frame  */
                   struct frame *recoFr, /* Out: Reconstruction frame      */
                   object *currRegion,   /* In:  Ptr to the region to code */
                   object *object_list,
				           int redionIndex, /* index of current region */
                   int picSizeX,         /* In:  Width of the image        */
                   int picSizeY,         /* In:  Height of the image       */
                   int regionSize,       /* In:  Region size (16 or 8)     */
                   int predPossible,     /* In:  Is motion pred possible   */
                   u_char *pecMode,      /* Out: Pred error coding mode    */
                   int *bitsMode,        /* Out: Bits for mode             */
                   int *bitsOvr,         /* Out: Bits for DCT CNC patterns */
                   int *bitsDct,         /* Out: Bits for luma DCT         */
                   int *bitsDctC,        /* Out: Bits for chrom DCT        */
                   int qp,               /* In:  Quant. param. for luma    */
                   float lambda_Y,       /* In:  Lambda param. for luma    */
                   int buildReco,        /* In:  Build reconstruction      */
                   int send);            /* In:  Dump output to bitstream  */

#endif
