#ifndef _ENCMCC_H_
#define _ENCMCC_H_

/*
 * encMCC.h
 *
 *    Copyright (c) 1995-2000 Nokia Research Center
 *
 * Contains:
 *    Functions for prediction error coding.
 *
 */


#include "mainFlags.h"
#include "toolMCC.h"

/*
 * Defines
 */


/*
 * Structs and typedefs
 */


/*
 * Function prototypes
 */

int enc8x8Block(int *diffBlkInput, int *methInfo, int qp, int lambdaInput,
                int methodInput, int classInput, int *bitsForSelect4x4,
                int *bitsForMethod, int *bitsForSelect8x8, int *seAfter,
                int *predBlkInput, int *dctCoeffs, int chroma, int mode,
                u_char predDirIn, int fastBest, int prevLagr, int cncBits, 
                int interFlag, int complexityMode);

int enc4x4Block(int *diffBlk, int *predBlk, int *origBlk, int *seAfter,
                int *bitsForCoef, int *info4x4, int method, int lambda,
                int qp, int *dctCoeffs, int *extrBlk, int extPels,
                int chroma, int mode, int prevMin, int blkSize, int fastBest,
                int predDir, int cncBits, int ncEnergy, int interFlag, 
                int complexityMode);

void mceMakeDiff(int *origBlk, int *predBlk, int *recoBlk, int *diffBlk,
                 int blkSize);

#endif  /* _ENCMCC_H_ */
