#include "mainFlags.h"
#include "IntraPredDecoder.h"
#include "mcp.h"
#include "tools.h"
#include "encMux.h"

int
  triplet_counter_Y,
  intra_dc_counter_Y,
  doublet_counter_Y,
  vq_counter_Y,
  rdc_counter_Y;

int *region_intra_dc     = NULL;
triplet *region_triplets = NULL;
doublet *region_doublets = NULL;
triplet *vq_triplets     = NULL;
int *rdc_value           = NULL;
int triplet_counter  = 0;
int intra_dc_counter = 0;
int doublet_counter  = 0;
int vq_counter       = 0;
int rdc_counter      = 0;

void alloc_triplets_if_needed(long picSize)
{
  static long
    alloccated_size = 0;

  if (alloccated_size < picSize)
  {
    if (alloccated_size > 0)
    {
      free((void *)region_triplets);
      free((void *)region_doublets);
      free((void *)vq_triplets);
      free((void *)rdc_value);
      free((void *)region_intra_dc);
    }

    alloccated_size = picSize;

    if((region_triplets =
        (triplet *)malloc((3*picSize) * sizeof(triplet)/2)) == NULL) {
      fprintf(stderr,"Cannot allocate mem for region triplets!\n");
      exit(1);
    }
    if((region_doublets = (doublet *)malloc((3*picSize/64) *
        sizeof(doublet))) == NULL) {
      fprintf(stderr,"Cannot allocate mem for region doublets!\n");
      exit(1);
    }
    if((vq_triplets = (triplet*)malloc((3*picSize/2) *
        sizeof(triplet))) == NULL) {
      fprintf(stderr,"CAN't allocate memory for vq triplets!\n");
      exit(1);
    }
    if((rdc_value = (int *)malloc((3*picSize) * sizeof(int)/2)) == NULL) {
      fprintf(stderr,"Cannot allocate memory for rdc_value!\n");
      exit(1);
    }
    if((region_intra_dc = (int *)malloc((3*picSize) * sizeof(int)/2)) == NULL) {
      fprintf(stderr,"Can not allocate mem for region intra_dc!\n");exit(1);
    }
  }
}


